/* pcibios.h */


#define REAL_MODE   0
#define PROT16_MODE 1
#define PROT32_MODE 2

/* Configuration Space Header Offsets */
#define OFF_VENDOR_ID	0x00
#define OFF_DEVICE_ID	0x02
#define OFF_COMMAND	   0x04
#define OFF_STATUS	   0x06
#define OFF_REVISION_ID	0x08
#define OFF_PROG_IN	   0x09
#define OFF_SUB_CLASS	0x0a
#define OFF_BASE_CLASS	0x0b
#define OFF_CACHELS	   0x0c
#define OFF_LATTIMER	0x0d
#define OFF_HEADERTYPE	0x0e
#define OFF_BIST	      0x0f

#define OFF_BASE_ADDR   0x10
#define OFF_INT_LINE    0x3C

//#define OFF_PERIODIC_INT 0x40

/************************** bios functions *******************/
int pci_init(void);
int pci_get_status(int far *major_version,
                   int far *minor_version,
                   int far *last_bus,
                   int far *access_flags);
int pci_find_device(int DevId,
                    int VenId,
                    int Index,
                    int far *bus_number,
                    int far *function_number,
                    int far *device_number);
int pci_read_word(int BusNum,
                  int DevNum,
                  int FuncNum,
                  int RegNum,
                  WORD far *config_reg);
int pci_read_byte(int BusNum,
                  int DevNum,
                  int FuncNum,
                  int RegNum,
                  BYTE far *config_reg);

#ifdef UNUSED_FUNCS
int pci_read_dword(int BusNum,
                  int DevNum,
                  int FuncNum,
                  int RegNum,
                  DWORD *config_reg);
int pci_write_dword(int BusNum,
                  int DevNum,
                  int FuncNum,
                  int RegNum,
                  DWORD config_reg);
int pci_write_word(int BusNum,
                  int DevNum,
                  int FuncNum,
                  int RegNum,
                  WORD config_reg);
int pci_write_byte(int BusNum,
                  int DevNum,
                  int FuncNum,
                  int RegNum,
                  BYTE config_reg);
#endif

/*---- RocketPort specific PCI information ----*/
/* PCI Defines */
#define PCI_VENDOR_ID	     0x11fe
#define PCI_DEVICE_8RJ       0x0006
#define PCI_DEVICE_4Q        0x0004
#define PCI_DEVICE_8O        0x0005
#define PCI_DEVICE_8I        0x0002
#define PCI_DEVICE_16I       0x0003
#define PCI_DEVICE_32I       0x0001
#define PCI_DEVICE_RPLUS4    0x000a
#define PCI_DEVICE_RPLUS8    0x000b
#define PCI_DEVICE_SIEMENS8    0x0008
#define PCI_DEVICE_SIEMENS16   0x0009

