;*****************************************************************************
;File:    SSCIA.ASM
;Project: RocketPort System to Serial Controller Interface
;Company: Comtrol Corporation
;Author:  Craig Harrison
;******************************************************************************
;Copyright 1993 Comtrol Corporation. All rights reserved.
;This source code is Comtrol proprietary and may not be distributed outside
;of Comtrol Corporation.
;******************************************************************************

IF MMODEL EQ 0                         ;small model
.MODEL SMALL
PARMOFF equ 4
ELSE
   IF MMODEL EQ 1                      ;medium model
   .MODEL MEDIUM
   PARMOFF equ 6
   ELSE
      IF MMODEL EQ 2                   ;compact model
      .MODEL COMPACT
      PARMOFF equ 4
      ELSE
         IF MMODEL EQ 3                ;large model
         .MODEL LARGE
         PARMOFF equ 6
         ELSE
            .ERR "Memory model incorrectly defined"
         ENDIF
      ENDIF
   ENDIF
ENDIF

.CODE


;****************************************************************************
;Function: sOutDWord
;Purpose:  Double word write to I/O space
;Call:     sOutDWord(io,Val)
;          unsigned int io: I/O address
;          unsigned long Val: Value to output
;Return:   void

         public  _sOutDWord
_sOutDWord proc
         push    bp                            ;save old frame pointer
         mov     bp,sp                         ;establish current frame pointer
         mov     dx,word ptr [bp+PARMOFF]      ;get I/O address parameter
;        mov     eax,dword ptr [bp+PARMOFF+2]  ;get Value to output parameter
         db      66h,8Bh,46h,PARMOFF+2         ;  opcode for 386 instruction
;        out     dx,eax                        ;write it out
         db      66h,0efh                      ;  opcode for 386 instruction
         pop     bp                            ;restore frame pointer
         ret
_sOutDWord endp

         end
